<?PHP

if (defined('PHP_VERSION_ID')) {
	function sqlite_changes($db) {
		return $db->changes();
	}

	function sqlite_close($db) {
		return $db->close();
	}

	function sqlite_error_string($string) {
		return $string;
	}

	function sqlite_escape_string($string) {
		return SQLite3::escapeString($string);
	}

	function sqlite_exec($db, $sql) {
		return $db->exec($sql);
	}

	function sqlite_fetch_all($sql_result) {
		$rows = array();
		if ($sql_result) {
			while ($row = $sql_result->fetchArray()) {
				$rows[] = $row;
			}
		}
		return $rows;
	}

	function sqlite_fetch_array(&$sql_result) {
		if ($sql_result) {
			$row = $sql_result->fetchArray();
			return $row;
		}
		return false;
	}

	function sqlite_fetch_column_types($sql_table, $db) {
		$column_types = array();
		if ($sql_result = $db->query("SELECT * FROM $sql_table")) {
			$sql_result->fetchArray(SQLITE3_NUM);
			for ($column = 0; $column < $sql_result->numColumns(); $column++) {
				$column_types[$sql_result->columnName($column)] = $sql_result->columnType($column);
			}
		}
		return $column_types;
	}

	function sqlite_fetch_single(&$sql_result) {
		// TODO: TOTEST
		if ($sql_result) {
			$row = $sql_result->fetchArray();
			return isset($row[0]) ? $row[0] : '';
		}
		return false;
	}

	function sqlite_has_more($sql_result) {
		return $sql_result->numColumns() && $sql_result->columnType(0);
	}

	function sqlite_last_error($db) {
		return $db->lastErrorMsg() . " code (". $db->lastErrorCode() .")";
	}

	function sqlite_num_fields() {
		// TODO
	}

	function sqlite_num_rows($sql_result) {
		$nb_row = 0;
		if ($sql_result) {
			while ($row = $sql_result->fetchArray()) {
				$nb_row += 1;
			}
		}
		return $nb_row;
	}

	function sqlite_open($db_file, $permission = null, $key_encryption = null) {
		$db = null;
		if (is_null($permission)) {
			$db = new SQLite3($db_file);
		}
		else {
			$db = new SQLite3($db_file, SQLITE3_OPEN_READWRITE | SQLITE3_OPEN_CREATE);
		}
		return $db;
	}

	function sqlite_query($db, $sql) {
		return $db->query($sql);
	}

	function sqlite_rewind(&$sql_result) {
		// TODO: must find a practice test
	}
}
?>
